-- Fairy Init

freeslot("MT_ACEFAIRY", "SPR_FIDL", "S_ACEFAIRY", "S_ACEFAIRY_COLLECT", "S_ACEFAIRY_POINT",
"MT_ACEFAIRY_BUBBLE", "S_ACEFAIRY_BUBBLE", "S_ACEFAIRY_BUBBLE_POP")

mobjinfo[MT_ACEFAIRY] =
{
	spawnstate = S_ACEFAIRY,
	deathstate = S_ACEFAIRY,
	spawnhealth = 3,
	radius = 15*FRACUNIT,
	height = 20*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
states[S_ACEFAIRY] = {SPR_FIDL, A, -1, nil, 0, 0, S_ACEFAIRY}
states[S_ACEFAIRY_COLLECT] = {SPR_FIDL, A, -1, nil, 0, 0, S_ACEFAIRY}
states[S_ACEFAIRY_POINT] = {SPR_FIDL, A, 10, nil, 0, 0, S_ACEFAIRY}

mobjinfo[MT_ACEFAIRY_BUBBLE] =
{
	spawnstate = S_ACEFAIRY_BUBBLE,
	deathstate = S_ACEFAIRY_BUBBLE_POP,
	spawnhealth = 1,
	radius = 15*FRACUNIT,
	height = 20*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}
states[S_ACEFAIRY_BUBBLE] = {SPR_BUBS, K, -1, nil, 0, 0}
states[S_ACEFAIRY_BUBBLE_POP] = {SPR_BUBS, 0, 0, nil, 0, 0, S_NULL}

-- Fairy Setup

addHook("ThinkFrame", function()
	for player in players.iterate
		if player.realmo and player.wiz
			if player.wiz.fairy and player.wiz.fairy.valid and player.wiz.fairy.target
				
				-- Movement
				
				if player.wiz.fairy.health
					if player.wiz.fairy.tracer and player.wiz.fairy.tracer.valid
						if ARTH_Ace.AceCollectible[player.wiz.fairy.tracer.type][1] //and player.wiz.fairy.state != S_ACEFAIRY_POINT
							player.wiz.fairy.newx = player.wiz.fairy.tracer.x
							player.wiz.fairy.sidex = 0
							player.wiz.fairy.newy = player.wiz.fairy.tracer.y
							player.wiz.fairy.sidey = 0
							player.wiz.fairy.newz = player.wiz.fairy.tracer.z
							
							player.wiz.fairy.angle = R_PointToAngle2(player.wiz.fairy.x, player.wiz.fairy.y, player.wiz.fairy.tracer.x, player.wiz.fairy.tracer.y)
						/*elseif ARTH_Ace.AceCollectible[player.wiz.fairy.tracer.type][2] and player.wiz.fairy.state == S_ACEFAIRY_POINT
							player.wiz.fairy.newx = min(player.wiz.fairy.point.x - player.wiz.fairy.target.x, player.wiz.fairy.target.x + 512*player.wiz.fairy.target.scale)
							player.wiz.fairy.sidex = 0
							player.wiz.fairy.newy = min(player.wiz.fairy.point.y - player.wiz.fairy.target.y, player.wiz.fairy.target.y + 512*player.wiz.fairy.target.scale)
							player.wiz.fairy.sidey = 0
							player.wiz.fairy.newz = min(player.wiz.fairy.point.z - player.wiz.fairy.target.z, player.wiz.fairy.target.z + 512*player.wiz.fairy.target.scale)
							
							player.wiz.fairy.angle = R_PointToAngle2(player.wiz.fairy.x, player.wiz.fairy.y, player.wiz.fairy.point.x, player.wiz.fairy.point.y)*/
						end
						
						local dist = P_AproxDistance(P_AproxDistance(player.wiz.fairy.x - player.wiz.fairy.target.x, player.wiz.fairy.y - player.wiz.fairy.target.y), player.wiz.fairy.z - player.wiz.fairy.target.z)
						
						if (not P_CheckSight(player.wiz.fairy.target, player.wiz.fairy.tracer)
						or not (dist >= 0 and dist < 512*player.wiz.fairy.target.scale)
						or not player.wiz.fairy.tracer.health or player.wiz.fairy.tracer.collected
						or P_PlayerInPain(player.wiz.fairy.target.player) or player.playerstate != PST_LIVE)
							player.wiz.fairy.tracer = nil
						end
					else
						player.wiz.fairy.newx = player.wiz.fairy.target.x + FixedMul(cos(player.wiz.fairy.target.player.drawangle), player.wiz.fairy.target.radius - player.wiz.fairy.radius - 50*FRACUNIT)
						player.wiz.fairy.newy = player.wiz.fairy.target.y + FixedMul(sin(player.wiz.fairy.target.player.drawangle), player.wiz.fairy.target.radius - player.wiz.fairy.radius - 50*FRACUNIT)
						
						if not (player.wiz.fairy.eflags & MFE_VERTICALFLIP)
							player.wiz.fairy.newz = player.wiz.fairy.target.z + player.wiz.fairy.target.height
						else
							player.wiz.fairy.newz = player.wiz.fairy.target.z - player.wiz.fairy.height
						end
						
						if player.playerstate == PST_LIVE and not (player.wiz.fairy.target.flags2 & MF2_TWOD)
						and player.powers[pw_carry] != CR_NIGHTSMODE and player.powers[pw_carry] != CR_ZOOMTUBE
							if leveltime % (12*TICRATE) == 0
								player.wiz.fairy.side = P_RandomChance(FRACUNIT/2) and -1 or 1
							end
							
							player.wiz.fairy.sidex = ease.inoutsine(1*FRACUNIT/12, player.wiz.fairy.sidex, P_ReturnThrustX(player.wiz.fairy, player.wiz.fairy.angle - ANGLE_90 * player.wiz.fairy.side, FixedMul(50*FRACUNIT, player.wiz.fairy.target.scale)))
							player.wiz.fairy.sidey = ease.inoutsine(1*FRACUNIT/12, player.wiz.fairy.sidey, P_ReturnThrustY(player.wiz.fairy, player.wiz.fairy.angle - ANGLE_90 * player.wiz.fairy.side, FixedMul(50*FRACUNIT, player.wiz.fairy.target.scale)))
						else
							player.wiz.fairy.sidex = 0
							player.wiz.fairy.sidey = 0
						end
						
						player.wiz.fairy.angle = player.wiz.fairy.target.player.drawangle
						
						-- Tracker
						
						searchBlockmap("objects", function(mo, collectible)
							if collectible and collectible.valid and ARTH_Ace.AceCollectible[collectible.type]
								local dist1 = P_AproxDistance(P_AproxDistance(collectible.x - player.wiz.fairy.target.x, collectible.y - player.wiz.fairy.target.y), collectible.z - player.wiz.fairy.target.z)
								local dist2 = P_AproxDistance(P_AproxDistance(player.wiz.fairy.x - collectible.x, player.wiz.fairy.y - collectible.y), player.wiz.fairy.z - collectible.z)
								
								if not player.wiz.fairy.tracer and P_CheckSight(player.wiz.fairy.target, collectible)
								and not P_PlayerInPain(player.wiz.fairy.target.player) and player.powers[pw_carry] != CR_NIGHTSMODE
								and not collectible.tracer and player.playerstate == PST_LIVE and ARTH_Ace.AceCollectible[collectible.type][1]
									if ((dist1 >= 0 and dist1 < 256*player.wiz.fairy.target.scale)
									or (dist2 >= 0 and dist2 < 128*player.wiz.fairy.target.scale))
									and collectible.health and not collectible.collected
										player.wiz.fairy.tracer = collectible
										player.wiz.fairy.tracer.tracer = player.wiz.fairy
									end
								end
							end
						end, player.wiz.fairy.target,
						player.wiz.fairy.target.x - RING_DIST, player.wiz.fairy.target.x + RING_DIST,
						player.wiz.fairy.target.y - RING_DIST, player.wiz.fairy.target.y + RING_DIST)
					end
				else
					player.wiz.fairy.newx = player.wiz.fairy.target.x + FixedMul(cos(player.wiz.fairy.target.player.drawangle), player.wiz.fairy.target.radius - player.wiz.fairy.radius)
					player.wiz.fairy.newy = player.wiz.fairy.target.y + FixedMul(sin(player.wiz.fairy.target.player.drawangle), player.wiz.fairy.target.radius - player.wiz.fairy.radius)
					
					if not (player.wiz.fairy.eflags & MFE_VERTICALFLIP)
						player.wiz.fairy.newz = player.wiz.fairy.target.z + player.wiz.fairy.target.height
					else
						player.wiz.fairy.newz = player.wiz.fairy.target.z - player.wiz.fairy.height
					end
					
					player.wiz.fairy.sidex = 0
					player.wiz.fairy.sidey = 0
					
					player.wiz.fairy.angle = player.wiz.fairy.target.player.drawangle
				end
				
				-- Find
				
				/*if player.ytap and player.playerstate == PST_LIVE
				and not P_PlayerInPain(player) and player.mo.state != S_PLAY_ROLL
					if player.wiz.fairy.point and player.wiz.fairy.point.valid
						if player.wiz.fairy.state != S_ACEFAIRY_POINT
							player.wiz.fairy.state = S_ACEFAIRY_POINT
						end
					//else
						
					end
				end*/
				
				-- Shield
				
				local LT = BT_CUSTOM1
				local player = player.wiz.fairy.target.player
				
				if player.wiz
					player.wiz.parry = player.wiz.parrytime > 0
					player.wiz.parrytime = max($-1, 0)
					
					if (player.cmd.buttons & LT) and player.playerstate == PST_LIVE
					and not P_PlayerInPain(player) and player.mo.state != S_PLAY_ROLL
					and not player.wiz.jumpability and not player.wiz.twistability
					and not player.wiz.shieldrecharge and not player.wiz.shielddelay
					and not player.wiz.casting and not player.gotflag
					or player.playerstate == PST_LIVE and (player.mo.state != S_PLAY_PAIN
					or (player.pflags & PF_SLIDING)) and player.powers[pw_flashing]
						if player.powers[pw_flashing]
							player.wiz.shieldtime = player.powers[pw_flashing]
						end
						
						if player.wiz.shieldtime > 0
							player.wiz.shield = true
							player.wiz.shieldtime = $-1
							
							if not player.wiz.shieldorb or not player.wiz.shieldorb.valid
								if player.lttap
									player.wiz.parrytime = 2
								end
								
								player.wiz.shieldorb = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ACESHIELD)
								
								if player.wiz.shieldorb and player.wiz.shieldorb.valid
									player.wiz.shieldorb.scale = 1*FRACUNIT/4
									player.wiz.shieldorb.scalespeed = 1*FRACUNIT/4
									player.wiz.shieldorb.target = player.mo
									
									S_StartSound(mobj, sfx_shield)
								end
							end
						else
							player.wiz.shieldrecharge = true
						end
					else
						if player.wiz.shield
							player.wiz.shield = false
							player.wiz.shielddelay = 15
							
							S_StartSound(mobj, sfx_ngskid)
						end
						
						player.wiz.shieldtime = min($+1, 100)
						
						if player.wiz.shieldorb and player.wiz.shieldorb.valid
							player.wiz.shieldorb.destscale = 0
							
							if player.wiz.shieldorb.scale <= 1*FRACUNIT/96
								P_RemoveMobj(player.wiz.shieldorb)
							end
						end
					end
					
					if player.lttap and player.wiz.shieldrecharge
						player.wiz.shieldrecharge = false
					end
					
					player.wiz.shielddelay = max($-1, 0)
				end
			else
				player.wiz.fairy = P_SpawnMobjFromMobj(player.mo,
				player.rmomx + FixedMul(cos(player.drawangle), player.mo.radius - mobjinfo[MT_ACEFAIRY].radius - 50*FRACUNIT)
				+ P_ReturnThrustX(mobj, player.drawangle - ANGLE_90, FixedMul(50*FRACUNIT, player.mo.scale)),
				player.rmomy + FixedMul(sin(player.drawangle), player.mo.radius - mobjinfo[MT_ACEFAIRY].radius - 50*FRACUNIT)
				+ P_ReturnThrustY(mobj, player.drawangle - ANGLE_90, FixedMul(50*FRACUNIT, player.mo.scale)),
				player.mo.momz + player.mo.height, MT_ACEFAIRY)
				
				if player.realmo
					player.wiz.fairy.target = player.mo
				end
				
				player.wiz.fairy.newx = player.wiz.fairy.x
				player.wiz.fairy.newy = player.wiz.fairy.y
				player.wiz.fairy.newz = player.wiz.fairy.z
				
				player.wiz.fairy.side = -1
				
				player.wiz.fairy.sidex = P_ReturnThrustX(player.wiz.fairy, player.wiz.fairy.angle - ANGLE_90, FixedMul(50*FRACUNIT, player.wiz.fairy.target.scale))
				player.wiz.fairy.sidey = P_ReturnThrustY(player.wiz.fairy, player.wiz.fairy.angle - ANGLE_90, FixedMul(50*FRACUNIT, player.wiz.fairy.target.scale))
			end
		end
	end
end)

-- Fairy Thinker

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
		if mobj.target and mobj.target.valid and mobj.target.player.wiz
		and (mobj.target.skin == "ace" or mobj.target.player.wiz.allowed)
			if not G_GametypeHasTeams()
				mobj.color = R_GetColorByName(mobj.target.player.skincolor+15)
			else
				mobj.color = R_GetColorByName(mobj.target.player.skincolor)
			end
			
			if mobj.target.player.playerstate != PST_DEAD
				if mobj.health
					mobj.movedir = $ + FixedAngle(8*FRACUNIT)
				
					P_MoveOrigin(mobj,
					ease.inoutsine(1*FRACUNIT/3, mobj.x, mobj.newx + mobj.sidex),
					ease.inoutsine(1*FRACUNIT/3, mobj.y, mobj.newy + mobj.sidey),
					ease.inoutsine(1*FRACUNIT/3, mobj.z, mobj.newz)
					+ FixedMul(cos(mobj.movedir), 1*FRACUNIT/2))
					
					mobj.frame = $|FF_FULLBRIGHT
				else
					mobj.movedir = 0
					
					P_MoveOrigin(mobj, mobj.newx, mobj.newy, mobj.newz)
					
					mobj.frame = $&~FF_FULLBRIGHT
				end
			else
				if not (mobj.flags & MF_NOCLIP)
					mobj.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
					P_SetObjectMomZ(mobj, mobj.target.momz)
				end
				
				mobj.frame = $&~FF_FULLBRIGHT
			end
			
			if P_MobjFlip(mobj.target) > 0
				mobj.flags2 = $&~MF2_OBJECTFLIP
				mobj.eflags = $&~MFE_VERTICALFLIP
			else
				mobj.flags2 = $|MF2_OBJECTFLIP
				mobj.eflags = $|MFE_VERTICALFLIP
			end
			
			mobj.scale = mobj.target.scale
			
			if (mobj.eflags & MFE_UNDERWATER)
				if not (mobj.bubble and mobj.bubble.valid)
					mobj.bubble = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_ACEFAIRY_BUBBLE)
					mobj.bubble.target = mobj
				else
					A_CapeChase(mobj.bubble)
				end
			else
				if mobj.bubble and mobj.bubble.valid
					P_KillMobj(mobj.bubble)
				end
			end
			
			if not ARTH_Ace.AceHealth
				mobj.health = mobj.target.health
			end
		else
			P_RemoveMobj(mobj)
		end
	end
end, MT_ACEFAIRY)

addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid
		return false
	end
end, MT_ACEFAIRY)

-- Fariy Collect

local function FariyCollect(mobj, collectible)
	if mobj and mobj.valid and mobj.target and mobj.target.valid
	and collectible and collectible.valid
	and (ARTH_Ace.AceCollectible[collectible.type]
	and ARTH_Ace.AceCollectible[collectible.type][1])
		if mobj.tracer and collectible == mobj.tracer
		and (mobj.z <= collectible.z + collectible.height and mobj.z + mobj.height >= collectible.z)
		and collectible.health and not collectible.collected
			mobj.tracer = nil
			
			collectible.collected = true
			collectible.target = mobj.target
			collectible.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
			S_StartSound(mobj, sfx_thok)
			return false
		end
	end
end

addHook("MobjCollide", FariyCollect, MT_ACEFAIRY)
addHook("MobjMoveCollide", FariyCollect, MT_ACEFAIRY)

local function CollectibleThinker(collectible)
	if collectible and collectible.valid and collectible.health
	and ARTH_Ace.AceCollectible[collectible.type]
		if collectible.target and collectible.collected
			A_HomingChase(collectible, 30*FRACUNIT+collectible.target.player.speed)
			
			if not collectible.health
				collectible.collected = false
				collectible.target = nil
				collectible.tracer = nil
			end
		end
	end
end

addHook("MobjThinker", CollectibleThinker)

freeslot("MT_ACESHIELD", "S_ACESHIELD_ON", "S_ACESHIELD", "S_ACESHIELD_OFF", "SPR_ASHD")

-- Player Shield

mobjinfo[MT_ACESHIELD] =
{
	doomednum = -1,
	spawnstate = S_ACESHIELD,
	deathstate = S_ACESHIELD_OFF,
	//seesound = sfx_shield,
	//deathsound = sfx_ngskid,
	spawnhealth = 100,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}
states[S_ACESHIELD_ON] = {SPR_ASHD, 0, 0, nil, 0, 0, S_ACESHIELD}
states[S_ACESHIELD] = {SPR_ASHD, FF_ANIMATE|FF_FULLBRIGHT|FF_TRANS50, -1, nil, 9, 4}
states[S_ACESHIELD_OFF] = {SPR_ASHD, 0, 0, nil, 0, 0, S_NULL}

-- Shield Behavior

addHook("MobjThinker", function(shield)
	if shield and shield.valid
		if shield.target and shield.target.valid and shield.target.player.wiz
		and shield.target.player.wiz.fairy and shield.target.player.wiz.fairy.valid
			shield.color = R_GetColorByName(shield.target.player.wiz.fairy.color)
			
			local ShieldZ
			if P_MobjFlip(shield.target) > 0
				ShieldZ = shield.target.z + 2*FRACUNIT
				
				shield.flags2 = $&~MF2_OBJECTFLIP
				shield.eflags = $&~MFE_VERTICALFLIP
			else
				ShieldZ = shield.target.z - 2*FRACUNIT
				
				shield.flags2 = $|MF2_OBJECTFLIP
				shield.eflags = $|MFE_VERTICALFLIP
			end
			
			P_MoveOrigin(shield, shield.target.x, shield.target.y, ShieldZ)
			
			shield.angle = shield.target.player.drawangle
			
			if shield.target.skin == "ace"
				shield.destscale = shield.target.player.shieldscale
			else
				shield.destscale = shield.target.player.shieldscale*3/2
			end
		else
			P_RemoveMobj(shield)
		end
	end
end, MT_ACESHIELD)

local function ShieldCollide(shield, mobj)
	if not (mobj and mobj.valid and shield and shield.valid)
	or not ((mobj.flags & MF_ENEMY) /*or (mobj.flags & MF_MISSILE)
	or (mobj.flags & MF_PAIN)*/ or (mobj.flags & MF_PUSHABLE))
	or shield.target == mobj //or mobj.reflected
		return
	end
	
	if mobj.z - mobj.scale <= shield.z + shield.height
	and mobj.z + mobj.height + mobj.scale >= shield.z
		local PushAngle = R_PointToAngle2(shield.target.x, shield.target.y, mobj.x, mobj.y)
		
		if shield.target.player.wiz.parry
			/*if (mobj.flags & MF_MISSILE) or (mobj.flags & MF_PAIN)
				local Momz = mobj.momz
				local Missile = mobj.type
				
				if mobj.health
					mobj.target = nil
					mobj.state = mobjinfo[Missile].spawnstate
					
					P_InstaThrust(mobj, PushAngle, mobj.info.speed)
					mobj.momz = -Momz
				else
					local mobj = P_SPMAngle(shield, Missile, PushAngle)
					mobj.momz = -Momz
					mobj.reflected = true
				end
				
				-- TODO: Reverse mace speed
				
				if not shield.parried
					S_StartSound(shield, sfx_hoop2)
					shield.parried = true
				end
				
				shield.target.player.wiz.parrytime = 2
				shield.target.player.wiz.shieldtime = $+2
			end*/
			
			if (mobj.flags & MF_ENEMY) or (mobj.flags & MF_PUSHABLE)
				P_InstaThrust(mobj, PushAngle, mobjinfo[mobj.type].speed*8*FRACUNIT)
			end
			
			S_StartSound(shield, sfx_s259)
		else
			if shield.parried
				shield.parried = false
			end
			
			if (mobj.flags & MF_MISSILE)
				P_DamageMobj(mobj)
			end
			
			if (mobj.flags & MF_ENEMY) or (mobj.flags & MF_PUSHABLE)
				P_InstaThrust(mobj, PushAngle, shield.target.player.speed+PUSHACCEL)
			end
		end
	end
end

addHook("MobjCollide", ShieldCollide, MT_ACESHIELD)
addHook("MobjMoveCollide", ShieldCollide, MT_ACESHIELD)

-- Player Protection

addHook("ShouldDamage", function (target, inflictor, source, damage, damagetype)
	if target.player and target.player.valid and target.player.wiz
	and not (damagetype & DMG_DEATHMASK)
		if target.player.wiz.shield and not (damagetype and damagetype == DMG_NUKE)
		and target.player.wiz.shieldorb and target.player.wiz.shieldorb.valid
			return false
		end
	end
end, MT_PLAYER)

-- Give players a fairy (WIP)

/*local function PrintMsg(var)
	for player in players.iterate
		if player.realmo
			if var == 1
				CONS_Printf(player, "\x89\They now have a fairy.")
			elseif var == 2
				CONS_Printf(player, "\x89\They do not have a fairy anymore.")
			elseif var == 3
				CONS_Printf(player, "\x89\They already have a fairy.")
			end
			
			return
		end
	end
end

COM_AddCommand("GiveFairy", function(player, arg)
	for player in players.iterate
		if arg == "help"
			CONS_Printf(player, "\x89\A fairy can help you collect and find collectibles and can give you a shield.")
			
			if not splitscreen
				CONS_Printf(player, "\x89\You can give yourself and a bot a fairy. You can give a bot a fairy if you type; 'bot', 'ai' or their skin name beside the command.")
			else
				CONS_Printf(player, "\x89\You can give yourself and player 2 a fairy. You can give player 2 a fairy if you type; 'player 2', 'p2' beside the command.")
			end
		end
		
		if not splitscreen
			if not player.bot and (arg != "bot" and arg != "ai" and arg != (player.bot and player.mo.skin))
				if player.mo.skin != "ace" and not player.wiz
					player.wiz =
					{shield = false,
					shieldtime = 100,
					shieldrecharge = false,
					parry = false,
					parrytime = 0,
					allowed = true}
					
					CONS_Printf(player, "\x89\You now have a fairy.")
				elseif player.mo.skin != "ace" and player.wiz
					player.wiz = nil
					
					CONS_Printf(player, "\x89\You do not have a fairy anymore.")
				else
					CONS_Printf(player, "\x89\You already have a fairy.")
				end
			elseif player.bot and (arg == "bot" or arg == "ai" or arg == (player.bot and player.mo.skin))
				if player.bot and player.mo.skin != "ace" and not player.wiz
					player.wiz =
					{shield = false,
					shieldtime = 100,
					shieldrecharge = false,
					parry = false,
					parrytime = 0,
					allowed = true}
					
					PrintMsg(1)
				elseif player.bot and player.mo.skin != "ace" and player.wiz
					player.wiz = nil
					
					PrintMsg(2)
				elseif player.bot and player.mo.skin == "ace"
					PrintMsg(3)
				end
			elseif not player.bot and (arg == "bot" or arg == "ai" or arg == (player.bot and player.mo.skin))
				CONS_Printf(player, "\x89\There is no bot.")
			end
		else
			local player = players[1]
			
			if not player.bot and (arg != "player 2" and arg != "p2" and arg != (player.bot and player.mo.skin))
				if player.mo.skin != "ace" and not player.wiz
					player.wiz =
					{shield = false,
					shieldtime = 100,
					shieldrecharge = false,
					parry = false,
					parrytime = 0,
					allowed = true}
					
					CONS_Printf(player, "\x89\You now have a fairy.")
				elseif player.mo.skin != "ace" and player.wiz
					player.wiz = nil
					
					CONS_Printf(player, "\x89\You do not have a fairy anymore.")
				else
					CONS_Printf(player, "\x89\You already have a fairy.")
				end
			elseif player.bot and (arg == "player 2" or arg != "p2" or arg == (player.bot and player.mo.skin))
				if player.bot and player.mo.skin != "ace" and not player.wiz
					player.wiz =
					{shield = false,
					shieldtime = 100,
					shieldrecharge = false,
					parry = false,
					parrytime = 0,
					allowed = true}
					
					PrintMsg(1)
				elseif player.bot and player.mo.skin != "ace" and player.wiz
					player.wiz = nil
					
					PrintMsg(2)
				elseif player.bot and player.mo.skin == "ace"
					PrintMsg(3)
				end
			elseif not player.bot and (arg == "player 2" or arg != "p2" or arg == (player.bot and player.mo.skin))
				CONS_Printf(player, "\x89\Player 2 is missing.")
			end
		end
	end
end)*/